lev.gui

## Class LComboBox<T>

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - lev.gui.LComponent
      - - lev.gui.LHelpComponent
        - - lev.gui.LUserSetting<java.lang.Integer>
          - - lev.gui.LComboBox<T>

- Type Parameters:
    `T` -
  All Implemented Interfaces:
    java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable
  Direct Known Subclasses:
    LComboSearchBox

      public class LComboBox<T>
      extends LUserSetting<java.lang.Integer>

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class lev.gui.LUserSetting

      `LUserSetting.UpdateCaretHandler, LUserSetting.UpdateChangeHandler, LUserSetting.UpdateHandler`

    - ### Nested classes/interfaces inherited from class lev.gui.LHelpComponent

      `LHelpComponent.HelpActionHandler, LHelpComponent.HelpFocusHandler, LHelpComponent.HelpMouseHandler`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected javax.swing.JComboBox<T>` | `box`
    `protected LButton` | `enterButton`
    `protected T` | `previous`

    - ### Fields inherited from class lev.gui.LUserSetting

      `titleLabel`

    - ### Fields inherited from class lev.gui.LHelpComponent

      `followPos, help, helpPrefix, helpYoffset, save, saveTie, title`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LComboBox(java.lang.String title_)`
    `LComboBox(java.lang.String title_, java.awt.Font font, java.awt.Color shade)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addActionListener(java.awt.event.ActionListener a)`
    `void` | `addEnterButton(java.lang.String label, java.awt.event.ActionListener done)`
    `void` | `addFocusListener(java.awt.event.FocusListener f)`
    `void` | `addHelpHandler(boolean mouseListener)` Adds a help handler to each GUI component that should trigger the help panel to update.
    `void` | `addItem(T o)`
    `void` | `addMouseListener(java.awt.event.MouseListener m)`
    `protected void` | `addUpdateHandlers()` Abstract function that should add appropriate update handlers to the appropriate components.
    `void` | `clearHighlight()` Abstract function that should clear any GUI components of their highlighted state.
    `T` | `getSelectedItem()`
    `java.lang.Integer` | `getValue()`
    `void` | `highlightChanged()` Abstract function that should change some GUI component to symbolize it is highlighted.
    `boolean` | `isEmpty()`
    `void` | `removeAllItems()`
    `void` | `reset()`
    `boolean` | `revertTo(java.util.Map<java.lang.Enum,Setting> m)` Reverts the GUI component to to SaveFile instance specified.
    `void` | `savePrevious()`
    `void` | `setSelectedIndex(int in)`
    `void` | `setSize(int x, int y)`
    `void` | `switchTo(T o)`
    `void` | `switchToPrevious()`

    - ### Methods inherited from class lev.gui.LUserSetting

      `getName, isTied, tie, tie, update`

    - ### Methods inherited from class lev.gui.LHelpComponent

      `addHelpPrefix, getHelp, hasHelp, isFollowingPosition, linkTo, setFollowPosition, updateHelp`

    - ### Methods inherited from class lev.gui.LComponent

      `Add, centerIn, centerOn, centerOn, getBottom, getCenter, getRight, putUnder`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addNotify, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getInsets, getLayout, getListeners, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, isValidateRoot, layout, list, list, locate, minimumSize, paint, paintComponents, paramString, preferredSize, print, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, removeNotify, setComponentZOrder, setFocusCycleRoot, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, setLayout, transferFocusDownCycle, update, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAccessibleContext, getBackground, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getToolkit, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, reshape, resize, resize, revalidate, setBackground, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setMaximumSize, setMinimumSize, setName, setPreferredSize, setSize, setVisible, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### box

          protected javax.swing.JComboBox<T> box

    - #### previous

          protected T previous

    - #### enterButton

          protected LButton enterButton

  - ### Constructor Detail

    - #### LComboBox

          public LComboBox(java.lang.String title_)

      Parameters:
        `title_` -

    - #### LComboBox

          public LComboBox(java.lang.String title_,
                   java.awt.Font font,
                   java.awt.Color shade)

      Parameters:
        `title_` -
        `font` -
        `shade` -

  - ### Method Detail

    - #### setSize

          public void setSize(int x,
                     int y)

      Overrides:
        `setSize` in class `java.awt.Component`

    - #### addActionListener

          public void addActionListener(java.awt.event.ActionListener a)

      Parameters:
        `a` -

    - #### getSelectedItem

          public T getSelectedItem()

      Returns:

    - #### reset

          public void reset()

    - #### removeAllItems

          public void removeAllItems()

    - #### addItem

          public void addItem(T o)

      Parameters:
        `o` -

    - #### setSelectedIndex

          public void setSelectedIndex(int in)

      Parameters:
        `in` -

    - #### switchTo

          public void switchTo(T o)

      Parameters:
        `o` -

    - #### savePrevious

          public void savePrevious()

    - #### switchToPrevious

          public void switchToPrevious()

    - #### addHelpHandler

          public void addHelpHandler(boolean mouseListener)

      Description copied from class: `LHelpComponent`
      Adds a help handler to each GUI component that should trigger the help panel to update.
      Specified by:
        `addHelpHandler` in class `LHelpComponent`
      Parameters:
        `mouseListener` -

    - #### addFocusListener

          public void addFocusListener(java.awt.event.FocusListener f)

      Overrides:
        `addFocusListener` in class `java.awt.Component`

    - #### addMouseListener

          public void addMouseListener(java.awt.event.MouseListener m)

      Overrides:
        `addMouseListener` in class `java.awt.Component`

    - #### addUpdateHandlers

          protected void addUpdateHandlers()

      Description copied from class: `LUserSetting`
      Abstract function that should add appropriate update handlers to the appropriate components.
      Specified by:
        `addUpdateHandlers` in class `LUserSetting<java.lang.Integer>`

    - #### addEnterButton

          public void addEnterButton(java.lang.String label,
                            java.awt.event.ActionListener done)

      Parameters:
        `label` -
        `done` -

    - #### isEmpty

          public boolean isEmpty()

      Returns:

    - #### revertTo

          public boolean revertTo(java.util.Map<java.lang.Enum,Setting> m)

      Description copied from class: `LUserSetting`
      Reverts the GUI component to to SaveFile instance specified.
      Specified by:
        `revertTo` in class `LUserSetting<java.lang.Integer>`
      Returns:

    - #### getValue

          public java.lang.Integer getValue()

      Specified by:
        `getValue` in class `LUserSetting<java.lang.Integer>`
      Returns:

    - #### highlightChanged

          public void highlightChanged()

      Description copied from class: `LUserSetting`
      Abstract function that should change some GUI component to symbolize it is highlighted.
      Specified by:
        `highlightChanged` in class `LUserSetting<java.lang.Integer>`

    - #### clearHighlight

          public void clearHighlight()

      Description copied from class: `LUserSetting`
      Abstract function that should clear any GUI components of their highlighted state.
      Specified by:
        `clearHighlight` in class `LUserSetting<java.lang.Integer>`